
#define __KERNEL__
#define MODULE
#define __KERNEL_SYSCALLS__
#include <linux/module.h>

#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/file.h>
#include <linux/fs.h>

#include <linux/types.h>
#include <linux/unistd.h>

#include <linux/kernel.h>
#include <linux/malloc.h>
#include <linux/vmalloc.h>
#include <asm/uaccess.h>
#include <asm/msr.h>


#include "params.h"

int errno;

int init_module(void)
{
    unsigned int initial, final;
    char *buffer, *ptr;
    int i, fd;
    struct file * file;
    mm_segment_t fs;

    /* fake as user space */
    fs = get_fs();
    set_fs (get_ds());

    fd = open(FILENAME, O_RDONLY, 0);
    if (fd<0) {
	printk("open failed: %i\n", errno);
	set_fs (fs);
	return -errno;
    }

    /* allocate buffer (and don't check, which is bad) */
    buffer = (char *)vmalloc(BUFSIZE);
    if (!buffer) {
	printk("vmalloc failed\n");
	set_fs (fs);
	return -ENOMEM;
    }	


    /* use the same code we used in user space */
    #include "listing1.h"
    printk("A: %5i\n", (final-initial+500)/1000);

    #include "listing1.h"
    printk("A: %5i\n", (final-initial+500)/1000);

    #include "listing1.h"
    printk("A: %5i\n", (final-initial+500)/1000);


    /* retrieve a file pointer */
    file = fget(fd);

    /* use optimized code for kernel space */
    #include "listing2.h"
    printk("B: %5i\n", (final-initial+500)/1000);

    #include "listing2.h"
    printk("B: %5i\n", (final-initial+500)/1000);

    #include "listing2.h"
    printk("B: %5i\n", (final-initial+500)/1000);

    /* restore everything */
    vfree(buffer);
    set_fs (fs);
    return -EINVAL; /* let insmod fail */
}

